VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DPlot_GetEnhMetaFile Test"
   ClientHeight    =   7365
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9060
   LinkTopic       =   "Form1"
   ScaleHeight     =   7365
   ScaleWidth      =   9060
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command5 
      Caption         =   "Print"
      Height          =   495
      Left            =   240
      TabIndex        =   5
      Top             =   6000
      Width           =   1095
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Copy"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   5400
      Width           =   1095
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H80000005&
      FillColor       =   &H000000C0&
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000001&
      Height          =   7215
      Left            =   1680
      ScaleHeight     =   7155
      ScaleWidth      =   7155
      TabIndex        =   3
      Top             =   120
      Width           =   7215
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Contour Plot Random Data"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1560
      Width           =   1335
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Contour Plot Gridded Data"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "XY Plot"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 0
Dim DPlotWasActive As Long
Dim hemf As Long
Dim SizeX As Single
Dim SizeY As Single
Dim hwndDPlot As Long
Dim DocNum As Long
Dim d As DPLOT
Private Sub Command1_Click()

    Dim i As Long
    Dim NP As Long
    Dim X() As Single
    Dim Y() As Single
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
        
' Plot sin(PI*x) and cos(PI*x) from x = 0 to 4.
' In this case we've used DATA_XYYY (one X array for one or more Y arrays).
'
' Since the X values are evenly spaced we could also use
' DATA_DXY  - X has only 2 elements, DX and X0
'
' And you can ALWAYS use
' DATA_XYXY - Each curve uses its own X array. This is the only
'             option available if the curves have different X values or
'             a different number of points.
        
    PI = 4# * Atn(1#)
    NP = 1001
    ReDim X(0 To NP - 1) As Single
    ReDim Y(0 To 2 * NP - 1) As Single
    
    For i = 0 To NP - 1
        X(i) = (4# * i) / (NP - 1)
        Y(i) = Sin(PI * X(i))
        Y(i + NP) = Cos(PI * X(i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_XYYY
    d.MaxCurves = 2         ' Must be >= number of curves we plot
    d.MaxPoints = NP        ' Anything >= NP will do
    d.NumCurves = 2
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.LegendX = 0.05
    d.LegendY = 0.05
    d.NP(0) = NP
    d.NP(1) = NP
    d.LineType(0) = LINESTYLE_SOLID
    d.LineType(1) = LINESTYLE_LONGDASH
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = ""
    d.Title3 = ""
    d.XAxis = "x" & Chr$(0)
    d.YAxis = "y" & Chr$(0)
        
' The command string can be as complex as you like, limited to 32K characters.
' As an alternative, if your program will be producing many similar plots then
' you might prefer to create a preferences file, edit the file with a text
' editor to remove unwanted entries, and use the [GetPreferences("filename")]
' command.
    cmds = "[ManualScale(0,-1.25,4,1.25)][TickInterval(1,0.5,0.25)]"
    cmds = cmds & "[Color(1,255,0,0)][Color(2,0,0,255)]"
    cmds = cmds & "[LineWidth(-2,20)][LineWidth(-1,20)][LineWidth(0,10)]"
' We set the legend using command strings rather than the DPLOT structure to
' bypass VB's Unicode weirdness.
' \s is DPlot-speak for "use symbol font"
    cmds = cmds & "[Legend(1,""sin({\sp}x)"")]"
    cmds = cmds & "[Legend(2,""cos({\sp}x)"")]"
    cmds = cmds & "[TextFont(1, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(2,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(3,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(4,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(5,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(6, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[ClearEditFlag()]"
   
    If (hemf <> 0) Then
        ret = DeleteEnhMetaFile(hemf)
        hemf = 0
    End If
    DocNum = DPlot_Plot(d, X(0), Y(0), cmds)
    If (DocNum > 0) Then
        hemf = DPlot_GetEnhMetaFile(DocNum, SizeX, SizeY)
        ' Be sure to do a FileClose after this call (if you're done with the document)
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    Call Picture1_Paint
    
End Sub

Private Sub Command2_Click()
'
'   Contour plot with points on a rectangular grid
'
    Dim i, j As Long
    Dim Nx As Long      ' Number of data columns (horizontal grid cells+1)
    Dim Ny As Long      ' Number of data rows (vertical grid cells+1)
    Dim extents(3) As Single
    Dim Z() As Single
    Dim X As Single
    Dim Y As Single
    Dim cmds As String
    Dim ret As Long
    
    Nx = 61
    Ny = 41
    ReDim Z(Nx * Ny - 1) As Single
    extents(0) = -3     ' xlo
    extents(1) = -2     ' ylo
    extents(2) = 3      ' xhi
    extents(3) = 2      ' yhi
    
    For i = 0 To Nx - 1
        X = extents(0) + ((extents(2) - extents(0)) * i) / (Nx - 1)
        For j = 0 To Ny - 1
            Y = extents(1) + ((extents(3) - extents(1)) * j) / (Ny - 1)
            Z(i * Ny + j) = Sin(X) * Cos(Y)
        Next j
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_3D
    d.MaxCurves = Nx - 1
    d.MaxPoints = Ny - 1
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Contour3D(0)][ContourMethod(1)][ContourGrid(0)][ContourAxes(1)]"
    cmds = cmds & "[ContourLegend(0)][ContourLevels(21,-1,1)]"
    cmds = cmds & "[ContourScales(1,1,1)]"
    cmds = cmds & "[TextFont(1, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(2,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(3,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(4,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(5,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(6, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[ClearEditFlag()]"
    
    If (hemf <> 0) Then
        ret = DeleteEnhMetaFile(hemf)
        hemf = 0
    End If
    DocNum = DPlot_Plot(d, extents(0), Z(0), cmds)
    If (DocNum > 0) Then
       hemf = DPlot_GetEnhMetaFile(DocNum, SizeX, SizeY)
       ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    Call Picture1_Paint

End Sub

Private Sub Command3_Click()
'
'   Sends randomly-placed x,y,z triplets to DPlot and produces a
'   contour plot. The random feature of this example is a bit nonsensical
'   since we're using an equation to generate the data. This DPlot feature
'   is much more useful for truly random data and/or data values that
'   aren't organized on a rectangular grid.
'
    Dim Node() As Single
    Dim i As Long
    Dim Nz As Long
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    Dim rc As RECT
    Dim Colors(0 To 5) As Long
    
    PI = 4# * Atn(1#)
    Nz = 1000
    ReDim Node(2, Nz - 1)
    
    For i = 0 To Nz - 1
        Node(0, i) = -PI + 2 * PI * Rnd
        Node(1, i) = -PI + 2 * PI * Rnd
        Node(2, i) = Sin(Node(0, i)) * Cos(Node(1, i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_3DR
    d.MaxCurves = 1
    d.MaxPoints = Nz
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    Colors(0) = RGB(0, 255, 0)
    Colors(1) = RGB(51, 204, 0)
    Colors(2) = RGB(102, 153, 0)
    Colors(3) = RGB(153, 102, 0)
    Colors(4) = RGB(204, 51, 0)
    Colors(5) = RGB(255, 0, 0)
        
    cmds = "[Contour3D(0)][ContourGrid(0)][ContourMethod(1)]"
    cmds = cmds & "[ContourLevels(21,-1,1)][ContourLegend(0)]"
    cmds = cmds & "[TextFont(1, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(2,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(3,12,700,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(4,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(5,10,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[TextFont(6, 8,  0,0,0,0,0,""Arial"")]"
    cmds = cmds & "[ContourColorScheme(2)]"
    cmds = cmds & "[ContourCustomColors(" & _
                Str$(Colors(0)) & "," & Str$(Colors(1)) & "," & _
                Str$(Colors(2)) & "," & Str$(Colors(3)) & "," & _
                Str$(Colors(4)) & "," & Str$(Colors(5)) & ")]"
    cmds = cmds & "[ClearEditFlag()]"
    
    If (hemf <> 0) Then
        ret = DeleteEnhMetaFile(hemf)
        hemf = 0
    End If
    DocNum = DPlot_Plot(d, 0&, Node(0, 0), cmds)
    If (DocNum > 0) Then
        hemf = DPlot_GetEnhMetaFile(DocNum, SizeX, SizeY)
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    Call Picture1_Paint

End Sub

Private Sub Command4_Click()
'
'   Copy enhanced metafile to the Clipboard
'
    Dim hemfCopy As Long
    Dim ret As Long
    
    If (hemf <> 0) Then
        ret = OpenClipboard(Me.hwnd)
        ret = EmptyClipboard()
        hemfCopy = CopyEnhMetaFile(hemf, 0&)
        ret = SetClipboardData(CF_ENHMETAFILE, hemfCopy)
        ret = CloseClipboard()
    Else
        Beep
    End If
End Sub

Private Sub Command5_Click()
'
'   Print enhanced metafile
'
    Const PRINT_MARGIN = 0.25
    Dim di As DOCINFO
    Dim pd As PrintDlg
    Dim rc As RECT
    Dim resX As Long        ' Printer resolution in dpi
    Dim resY As Long
    Dim MaxSizeX As Single  ' Maximum size of the output, in dots (accounting for margins)
    Dim MaxSizeY As Single
    Dim ActSizeX As Single  ' Actual output size, in dots
    Dim ActSizeY As Single
    Dim ret As Long
    Dim sc As Single     ' Scale factor we use to fit the picture on the page
    
    If (hemf = 0) Then
        Beep
        Exit Sub
    End If
    
    pd.lStructSize = Len(pd)
    pd.hwndOwner = Me.hwnd
    pd.flags = PD_RETURNDC + PD_NOPAGENUMS + PD_NOSELECTION
    pd.nCopies = 1
    ret = PrintDlg(pd)
    If (ret = 0) Then
        Exit Sub
    End If
    If (pd.nCopies = 0) Then
        Exit Sub
    End If
    resX = GetDeviceCaps(pd.hdc, LOGPIXELSX)
    resY = GetDeviceCaps(pd.hdc, LOGPIXELSY)
    MaxSizeX = GetDeviceCaps(pd.hdc, HORZRES) - 2 * PRINT_MARGIN * resX
    MaxSizeY = GetDeviceCaps(pd.hdc, VERTRES) - 2 * PRINT_MARGIN * resY
    ret = EnableWindow(Me.hwnd, 0)
    di.cbSize = Len(di)
    di.lpszDocName = "DPlot_EnhMetaFile Demo"
    While (pd.nCopies > 0)
        If (StartDoc(pd.hdc, di) <> 0) Then
            ret = StartPage(pd.hdc)
            ' Center on the page, with at least PRINT_MARGIN margins.
            ' Compress the image if necessary, maintaining the
            ' SizeX/SizeY aspect ratio
            ActSizeX = SizeX * resX
            ActSizeY = SizeY * resY
            If (ActSizeX > MaxSizeX Or ActSizeY > MaxSizeY) Then
                sc = MaxSizeX / ActSizeX
                If (sc > MaxSizeY / ActSizeY) Then
                    sc = MaxSizeY / ActSizeY
                End If
                ActSizeX = ActSizeX * sc
                ActSizeY = ActSizeY * sc
            End If
            rc.Left = (PRINT_MARGIN * resX + (MaxSizeX - ActSizeX) / 2)
            rc.Top = (PRINT_MARGIN * resY + (MaxSizeY - ActSizeY) / 2)
            rc.Right = rc.Left + ActSizeX
            rc.Bottom = rc.Top + ActSizeY
            ret = PlayEnhMetaFile(pd.hdc, hemf, rc)
            ret = EndPage(pd.hdc)
            ret = EndDoc(pd.hdc)
        End If
        pd.nCopies = pd.nCopies - 1
    Wend
    ret = EnableWindow(Me.hwnd, 1)
    ret = DeleteDC(pd.hdc)
    If (pd.hDevMode <> 0) Then
        ret = GlobalFree(pd.hDevMode)
    End If
    If (pd.hDevNames <> 0) Then
        ret = GlobalFree(pd.hDevNames)
    End If
End Sub

Private Sub Form_Load()
    Dim rcPic As RECT
    Dim ret As Long
'
'   Ideally DPLOTLIB.DLL should reside in the same folder as your
'   compiled executable. Within the VB environment, though, finding
'   DPLOTLIB.DLL is a bit more problematic. The subroutine DPlot_FindDPLOTLIB
'   will search the registry for its location, then change the
'   working directory to that folder so that VB (actually Windows) will
'   find it.
    Call DPlot_FindDPLOTLIB
    
'   Start DPlot in a hidden state and find out whether it was already
'   active (we don't want to close it later if the user was already
'   running it).
    hwndDPlot = DPlot_Start(1, DPlotWasActive)
    DocNum = 0
    hemf = 0
    Call DPlot_SetErrorMethod(2)       ' Use MessageBox to report errors
    ret = GetClientRect(Picture1.hwnd, rcPic)
    ' Size of the metafile to retrieve, in inches. The actual size specified isn't critical
    ' *unless* we want font sizes in our output to exactly match what we specify. What IS
    ' fairly important is that the aspect ratio matches the aspect ratio of the output -
    ' otherwise squares won't be square, fonts will be stretched.
    SizeX = 5#
    SizeY = (SizeX * (rcPic.Bottom - rcPic.Top + 1)) / (rcPic.Right - rcPic.Left + 1)
    
End Sub

Private Sub Form_Terminate()
    Dim ret As Long
    If DPlotWasActive = 0 Then
        Call DPlot_Stop
    End If
    If hemf <> 0 Then
        ret = DeleteEnhMetaFile(hemf)
    End If
End Sub

Private Sub Picture1_Paint()
    Dim hdc As Long
    Dim ret As Long
    Dim rcPic As RECT
    
    If hemf <> 0 Then
        Picture1.Cls
        hdc = GetDC(Picture1.hwnd)
        ret = GetClientRect(Picture1.hwnd, rcPic)
        ret = PlayEnhMetaFile(hdc, hemf, rcPic)
        ret = ReleaseDC(Picture1.hwnd, hdc)
    End If
End Sub
