Attribute VB_Name = "Module1"
'
' General Windows stuff, taken from win32api.txt
'
Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Type DOCINFO
    cbSize As Long
    lpszDocName As String
    lpszOutput As String
End Type

Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Type SIZE
    cx As Long
    cy As Long
End Type

Type ENHMETAHEADER
    iType As Long
    nSize As Long
    rclBounds As RECT
    rclFrame As RECT
    dSignature As Long
    nVersion As Long
    nBytes As Long
    nRecords As Long
    nHandles As Integer
    sReserved As Integer
    nDescription As Long
    offDescription As Long
    nPalEntries As Long
    szlDevice As SIZE
    szlMillimeters As SIZE
    cbPixelFormat As Long
    offPixelFormat As Long
    bOpenGL As Long
End Type

Type POINTAPI
    X As Long
    Y As Long
End Type

Type PrintDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hdc As Long
    flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type

'  Ternary raster operations
Public Const SRCCOPY As Long = &HCC0020           ' (DWORD) dest = source
Public Const SRCPAINT As Long = &HEE0086          ' (DWORD) dest = source OR dest
Public Const SRCAND As Long = &H8800C6            ' (DWORD) dest = source AND dest
Public Const SRCINVERT As Long = &H660046         ' (DWORD) dest = source XOR dest
Public Const SRCERASE As Long = &H440328          ' (DWORD) dest = source AND (NOT dest )
Public Const NOTSRCCOPY As Long = &H330008        ' (DWORD) dest = (NOT source)
Public Const NOTSRCERASE As Long = &H1100A6       ' (DWORD) dest = (NOT src) AND (NOT dest)
Public Const MERGECOPY As Long = &HC000CA         ' (DWORD) dest = (source AND pattern)
Public Const MERGEPAINT As Long = &HBB0226        ' (DWORD) dest = (NOT source) OR dest
Public Const PATCOPY As Long = &HF00021           ' (DWORD) dest = pattern
Public Const PATPAINT As Long = &HFB0A09          ' (DWORD) dest = DPSnoo
Public Const PATINVERT As Long = &H5A0049         ' (DWORD) dest = pattern XOR dest
Public Const DSTINVERT As Long = &H550009         ' (DWORD) dest = (NOT dest)
Public Const BLACKNESS As Long = &H42             ' (DWORD) dest = BLACK
Public Const WHITENESS As Long = &HFF0062         ' (DWORD) dest = WHITE

' ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_NORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_MAXIMIZE = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9
Global Const SW_SHOWDEFAULT = 10
Global Const SW_MAX = 10

' SetWindowPos flags
Global Const SWP_NOSIZE = 1

' Predefined Clipboard Formats
Global Const CF_TEXT = 1
Global Const CF_BITMAP = 2
Global Const CF_METAFILEPICT = 3
Global Const CF_SYLK = 4
Global Const CF_DIF = 5
Global Const CF_TIFF = 6
Global Const CF_OEMTEXT = 7
Global Const CF_DIB = 8
Global Const CF_PALETTE = 9
Global Const CF_PENDATA = 10
Global Const CF_RIFF = 11
Global Const CF_WAVE = 12
Global Const CF_UNICODETEXT = 13
Global Const CF_ENHMETAFILE = 14
Global Const CF_OWNERDISPLAY = &H80
Global Const CF_DSPTEXT = &H81
Global Const CF_DSPBITMAP = &H82
Global Const CF_DSPMETAFILEPICT = &H83
Global Const CF_DSPENHMETAFILE = &H8E

' "Private" formats don't get GlobalFree()'d
Global Const CF_PRIVATEFIRST = &H200
Global Const CF_PRIVATELAST = &H2FF

' "GDIOBJ" formats do get DeleteObject()'d
Global Const CF_GDIOBJFIRST = &H300
Global Const CF_GDIOBJLAST = &H3FF

'  Device Parameters for GetDeviceCaps()
Global Const DRIVERVERSION = 0      '  Device driver version
Global Const TECHNOLOGY = 2         '  Device classification
Global Const HORZSIZE = 4           '  Horizontal size in millimeters
Global Const VERTSIZE = 6           '  Vertical size in millimeters
Global Const HORZRES = 8            '  Horizontal width in pixels
Global Const VERTRES = 10           '  Vertical width in pixels
Global Const BITSPIXEL = 12         '  Number of bits per pixel
Global Const PLANES = 14            '  Number of planes
Global Const NUMBRUSHES = 16        '  Number of brushes the device has
Global Const NUMPENS = 18           '  Number of pens the device has
Global Const NUMMARKERS = 20        '  Number of markers the device has
Global Const NUMFONTS = 22          '  Number of fonts the device has
Global Const NUMCOLORS = 24         '  Number of colors the device supports
Global Const PDEVICESIZE = 26       '  Size required for device descriptor
Global Const CURVECAPS = 28         '  Curve capabilities
Global Const LINECAPS = 30          '  Line capabilities
Global Const POLYGONALCAPS = 32     '  Polygonal capabilities
Global Const TEXTCAPS = 34          '  Text capabilities
Global Const CLIPCAPS = 36          '  Clipping capabilities
Global Const RASTERCAPS = 38        '  Bitblt capabilities
Global Const ASPECTX = 40           '  Length of the X leg
Global Const ASPECTY = 42           '  Length of the Y leg
Global Const ASPECTXY = 44          '  Length of the hypotenuse
Global Const LOGPIXELSX = 88        '  Logical pixels/inch in X
Global Const LOGPIXELSY = 90        '  Logical pixels/inch in Y
Global Const SIZEPALETTE = 104      '  Number of entries in physical palette
Global Const NUMRESERVED = 106      '  Number of reserved entries in palette
Global Const COLORRES = 108         '  Actual color resolution

'  Printing related DeviceCaps. These replace the appropriate Escapes
Global Const PHYSICALWIDTH = 110 '  Physical Width in device units
Global Const PHYSICALHEIGHT = 111 '  Physical Height in device units
Global Const PHYSICALOFFSETX = 112 '  Physical Printable Area x margin
Global Const PHYSICALOFFSETY = 113 '  Physical Printable Area y margin
Global Const SCALINGFACTORX = 114 '  Scaling factor x
Global Const SCALINGFACTORY = 115 '  Scaling factor y

Global Const PD_ALLPAGES = &H0
Global Const PD_SELECTION = &H1
Global Const PD_PAGENUMS = &H2
Global Const PD_NOSELECTION = &H4
Global Const PD_NOPAGENUMS = &H8
Global Const PD_COLLATE = &H10
Global Const PD_PRINTTOFILE = &H20
Global Const PD_PRINTSETUP = &H40
Global Const PD_NOWARNING = &H80
Global Const PD_RETURNDC = &H100
Global Const PD_RETURNIC = &H200
Global Const PD_RETURNDEFAULT = &H400
Global Const PD_SHOWHELP = &H800
Global Const PD_ENABLEPRINTHOOK = &H1000
Global Const PD_ENABLESETUPHOOK = &H2000
Global Const PD_ENABLEPRINTTEMPLATE = &H4000
Global Const PD_ENABLESETUPTEMPLATE = &H8000
Global Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
Global Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
Global Const PD_USEDEVMODECOPIES = &H40000
Global Const PD_USEDEVMODECOPIESANDCOLLATE = &H40000
Global Const PD_DISABLEPRINTTOFILE = &H80000
Global Const PD_HIDEPRINTTOFILE = &H100000
Global Const PD_NONETWORKBUTTON = &H200000

' GetStockObject constants
Global Const WHITE_BRUSH = 0
Global Const LTGRAY_BRUSH = 1
Global Const GRAY_BRUSH = 2
Global Const DKGRAY_BRUSH = 3
Global Const BLACK_BRUSH = 4
Global Const NULL_BRUSH = 5
Global Const HOLLOW_BRUSH = NULL_BRUSH
Global Const WHITE_PEN = 6
Global Const BLACK_PEN = 7
Global Const NULL_PEN = 8
Global Const OEM_FIXED_FONT = 10
Global Const ANSI_FIXED_FONT = 11
Global Const ANSI_VAR_FONT = 12
Global Const SYSTEM_FONT = 13
Global Const DEVICE_DEFAULT_FONT = 14
Global Const DEFAULT_PALETTE = 15
Global Const SYSTEM_FIXED_FONT = 16

' SetBkMode constants
Global Const TRANSPARENT = 1
Global Const OPAQUE = 2
Global Const NEWTRANSPARENT = 3

' Registry constants
Global Const HKEY_CLASSES_ROOT = &H80000000
Global Const HKEY_CURRENT_USER = &H80000001
Global Const HKEY_LOCAL_MACHINE = &H80000002
Global Const HKEY_USERS = &H80000003
Global Const HKEY_CURRENT_CONFIG = &H80000005
Global Const HKEY_DYN_DATA = &H80000006
Global Const REG_SZ = 1 'Unicode nul terminated string
Global Const REG_BINARY = 3 'Free form binary
Global Const REG_DWORD = 4 '32-bit number
Global Const ERROR_SUCCESS = 0&

Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function BringWindowToTop Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CloseClipboard Lib "user32" () As Long
Declare Function CopyEnhMetaFile Lib "gdi32" Alias "CopyEnhMetaFileA" (ByVal hemfSrc As Long, ByVal lpszFile As Any) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteEnhMetaFile Lib "gdi32" (ByVal hemf As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function DPtoLP Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function EmptyClipboard Lib "user32" () As Long
Declare Function EnableWindow Lib "user32" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As Any) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetEnhMetaFileHeader Lib "gdi32" (ByVal hemf As Long, ByVal cbBuffer As Long, ByRef lpemh As ENHMETAHEADER) As Long
Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Any) As Long
Declare Function GetLastError Lib "kernel32" () As Long
Declare Function GetMapMode Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function IsIconic Lib "user32" (ByVal hwnd As Long) As Long
Declare Function IsZoomed Lib "user32" (ByVal hwnd As Long) As Long
Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Declare Function PlayEnhMetaFile Lib "gdi32" (ByVal hdc As Long, ByVal hemf As Long, lpRect As RECT) As Long
Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PrintDlg) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal color As Long) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal mode As Long) As Long
Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Declare Function SetMapMode Lib "gdi32" (ByVal hdc As Long, ByVal nMapMode As Long) As Long
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DOCINFO) As Long
Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function UpdateWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function VerLanguageName Lib "kernel32" Alias "VerLanguageNameA" (ByVal wLang As Long, ByVal szLang As String, ByVal nSize As Long) As Long
Declare Function VerQueryValue Lib "version.dll" (pBlock As Any, ByVal lpSubBlock As String, ByVal lplpBuffer As Long, puLen As Long) As Long
'
' DPlot-specific stuff
'
Global Const DPLOT_DDE_VERSION = 3      ' Version 3 structure allows up to 100 data sets per plot

Type DPLOT
    version As Long             ' version number of this structure, should be set by caller to DPLOT_DDE_VERSION
    hwnd As Long                ' handle of client application window
    DataFormat As Long          ' XY pairs, DX and Y, etc. See DATA_ constants
    MaxCurves As Long           ' DataFormat    Description
                                ' DATA_XYXY     Max. number of curves, <= 100
                                ' DATA_DXY      ..
                                ' DATA_XYYY     ..
                                ' DATA_3D       Number of grid cells in X direction,
                                '                 = number of data columns-1
                                ' DATA_3DR      not used
                                ' DATA_1D       Max. number of groups, <= 100
                                ' DATA_3DS      Max. number of data sets, <= 100
    MaxPoints As Long           ' DATA_XYXY     Max. number of points/curve
                                ' DATA_DXY      ..
                                ' DATA_XYYY     ..
                                ' DATA_3D       Number of grid cells in Y direction,
                                '                 = number of data rows-1
                                ' DATA_3DR      Number of X,Y,Z triplets
                                ' DATA_1D       Max. number of points/group
                                ' DATA_3DS      Max. number of points/data set
    NumCurves As Long           ' Actual number of curves/groups, always 1 for
                                '   DATA_3D or DATA_3DR
    ScaleCode As Long           ' scaling code for XY plots (Linear, Log, etc.)
    LegendX As Single           ' left coord of legend, expressed as a ratio
                                '    of plot size (0->1) (CAN be negative and/or > 1,
                                '    but exact placement is then a bit hard to predict)
    LegendY As Single           ' top coord of legend, again expressed as a ratio
                                '    of plot size
    NP(0 To 99) As Long         ' Actual number of points in each curve/group. Not used for DATA_3D.
                                '   Cannot exceed MaxPoints.
    LineType(0 To 99) As Long   ' Line types (see codes below)
    SymbolType(0 To 99) As Long ' Symbol types (see codes below)
    SizeofExtraInfo As Long     ' Extra information following X,Y data. No need to
                                '   fill in this member for DPLOTLIB calls
    Legend As String * 8080     ' Legend(0->79) is the caption for the legend
                                ' Legend(n*80->n*80+79) is the caption for the n'th curve
                                ' Ideally this would be dimensioned as Legend(0 to 100) as String*80,
                                ' but VBA wants to do weird unicode conversion on the array when
                                ' we do that. Same problem exists for the Label array (next).
                                ' Fortunately we can get around this mess with individual DPlot commands.
    Label As String * 4000      ' Strings displayed beside the last data point
                                '   in a curve, 40 characters per curve
    Title1 As String * 80
    Title2 As String * 80
    Title3 As String * 80
    XAxis As String * 80        ' X Axis label.
    YAxis As String * 80        ' Y Axis label.
End Type

Type DPLOT_PLOTMETRICS
    SIZE As Long        ' size of this structure, should be filled in by the caller
    hll As Long         ' horizontal and
    vll As Long         '  vertical coordinates of the lower left corner of the plot, in pixels
    hur As Long         ' horizontal and
    vur As Long         '  vertical coordinates of the upper right corner of the plot, in pixels
    xlo As Single       ' value of x at the left plot extent
    ylo As Single       ' value of y at the bottom plot extent
    xhi As Single       ' value of x at the right plot extent
    yhi As Single       ' value of y at the top plot extent
End Type

Type DPLOT_PLOTMETRICSEX
    SIZE As Long        ' size of this structure, should be filled in by the caller
    hll As Long         ' horizontal and
    vll As Long         '  vertical coordinates of the lower left corner of the plot, in pixels
    hur As Long         ' horizontal and
    vur As Long         '  vertical coordinates of the upper right corner of the plot, in pixels
    xlo As Single       ' value of x at the left plot extent
    ylo As Single       ' value of y at the bottom plot extent
    xhi As Single       ' value of x at the right plot extent
    yhi As Single       ' value of y at the top plot extent
    stretch(0 To 2) As Single
    scale As Single
    azimuth As Single
    elevation As Single
End Type

Declare Function DPlot_3DBorder Lib "dplotlib" (ByVal DocNum As Long, ByVal NumPts As Long, ByRef points As Double) As Long
Declare Function DPlot_AddData Lib "dplotlib" (ByVal DocNum As Long, ByVal DataType As Long, ByVal NumPts As Long, ByVal Curve As Long, ByRef X As Single, ByRef Y As Single) As Long
Declare Function DPlot_AddData8 Lib "dplotlib" (ByVal DocNum As Long, ByVal DataType As Long, ByVal NumPts As Long, ByVal Curve As Long, ByRef X As Double, ByRef Y As Double) As Long
Declare Function DPlot_Command Lib "dplotlib" (ByVal DocNum As Long, ByVal Command As String) As Long
Declare Function DPlot_GetBitmap Lib "dplotlib" (ByVal DocNum As Long, ByVal cx As Long, ByVal cy As Long) As Long
Declare Function DPlot_GetBitmapEx Lib "dplotlib" (ByVal DocNum As Long, ByVal cx As Long, ByVal cy As Long, ByRef DPM As Any) As Long
Declare Function DPlot_GetEnhMetaFile Lib "dplotlib" (ByVal DocNum As Long, ByVal cx As Single, ByVal cy As Single) As Long
Declare Function DPlot_GetVersion Lib "dplotlib" (ByVal version As String) As Long
Declare Function DPlot_MinVersion Lib "dplotlib" (ByVal digit1 As Long, ByVal digit2 As Long, ByVal digit3 As Long, ByVal digit4 As Long) As Long
Declare Function DPlot_Plot Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Single, ByRef Y As Single, ByVal cmds As String) As Long
Declare Function DPlot_Plot8 Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Double, ByRef Y As Double, ByVal cmds As String) As Long
Declare Function DPlot_Plot8p Lib "dplotlib" (ByRef d As DPLOT, ByVal px As Long, ByVal py As Long, ByVal cmds As String) As Long
Declare Function DPlot_PlotBitmap Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Single, ByRef Y As Single, ByVal cmds As String, ByVal cx As Long, ByVal cy As Long) As Long
Declare Function DPlot_PlotBitmap8 Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Double, ByRef Y As Double, ByVal cmds As String, ByVal cx As Long, ByVal cy As Long) As Long
Declare Function DPlot_PlotToRect Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Single, ByRef Y As Single, ByVal cmds As String, ByVal hwnd As Long, ByRef rc As RECT) As Long
Declare Function DPlot_PlotToRect8 Lib "dplotlib" (ByRef d As DPLOT, ByRef X As Double, ByRef Y As Double, ByVal cmds As String, ByVal hwnd As Long, ByRef rc As RECT) As Long
Declare Function DPlot_Request Lib "dplotlib" (ByVal DocNum As Long, ByVal Item As String, ByVal Value As String, ByRef MaxCount As Long) As Long
Declare Sub DPlot_SetErrorMethod Lib "dplotlib" (ByVal method As Long)
Declare Function DPlot_Start Lib "dplotlib" (ByVal Minimize As Long, ByRef WasActive As Long) As Long
Declare Sub DPlot_Stop Lib "dplotlib" ()
Declare Function DPlot_ZFromXY Lib "dplotlib" (ByVal DocNum As Long, ByVal X As Double, ByVal Y As Double, ByRef Z As Double) As Long

' XY Scaling codes:

Global Const SCALE_LINEARX_LINEARY = 1
Global Const SCALE_LINEARX_LOGY = 2
Global Const SCALE_LOGX_LINEARY = 3
Global Const SCALE_LOGX_LOGY = 4
Global Const SCALE_TRIPARTITE = 5
Global Const SCALE_LINEARX_PROBABILITY = 6
Global Const SCALE_GRAINSIZE_DIST = 7
Global Const SCALE_POLAR = 8
Global Const SCALE_BARCHART = 9
Global Const SCALE_LOGX_PROBABILITY = 10
Global Const SCALE_PROBX_LINEARY = 11
Global Const SCALE_PROBX_LOGY = 12
Global Const SCALE_PROBX_PROBY = 13
Global Const SCALE_TRIANGLE_PLOT = 14
Global Const SCALE_N185 = 15

' Unit-specific scaling codes ... combine with above values using OR operator

Global Const UNITS_DEFAULT = 0
Global Const UNITS_TRIPARTITE_INCHES = UNITS_DEFAULT            ' Velocity (Y) in inches/sec
Global Const UNITS_TRIPARTITE_FEET = &H100                      '                 feet/sec
Global Const UNITS_TRIPARTITE_MILLIMETERS = &H200               '                 mm/sec
Global Const UNITS_TRIPARTITE_CENTIMETERS = &H300               '                 cm/sec
Global Const UNITS_TRIPARTITE_METERS = &H400                    '                 meters/sec
Global Const UNITS_GRAINSIZE_MILLIMETERS = UNITS_DEFAULT        ' Grain sizes (X) in mm
Global Const UNITS_GRAINSIZE_INCHES = &H100                     '                 inches
Global Const UNITS_POLAR_RADIANS = UNITS_DEFAULT                ' Rotation (X) in radians
Global Const UNITS_POLAR_DEGREES = &H100                        '                 degrees
Global Const UNITS_USERDEFINED = &H7F00

' Data organization following DPLOT structure:

Global Const DATA_XYXY = 0          ' One or more sets of X,Y data
Global Const DATA_DXY = 1           ' One or more X,Y curves. Constant spacing in X and same number of points in all curves.
Global Const DATA_XYYY = 2          ' One or more X,Y curves. All curves have the same X values.
Global Const DATA_3D = 3            ' Z values on a rectangular grid
Global Const DATA_3DR = 4           ' Random X,Y,Z values
Global Const DATA_IMAGE = 5         ' Used only by DPlot - there's no way to SEND DPlot an image
Global Const DATA_1D = 6            ' One or more groups of Y values.
Global Const DATA_3DS = 7           ' 3D scatter plot

' Line styles:
Global Const LINESTYLE_NONE = 0
Global Const LINESTYLE_SOLID = 1
Global Const LINESTYLE_LONGDASH = 2
Global Const LINESTYLE_DOTTED = 3
Global Const LINESTYLE_DASHDOT = 4
Global Const LINESTYLE_MEDDASH = 5
Global Const LINESTYLE_DASHDOTDOT = 6
Global Const LINESTYLE_DASHDOTDOTDOT = 7

' Symbol styles
Global Const SYMBOLSTYLE_NONE = 0
Global Const SYMBOLSTYLE_DOT = 1
Global Const SYMBOLSTYLE_CROSS = 2
Global Const SYMBOLSTYLE_ASTERISK = 3
Global Const SYMBOLSTYLE_X = 4
Global Const SYMBOLSTYLE_SQUARE = 5
Global Const SYMBOLSTYLE_DIAMOND = 6
Global Const SYMBOLSTYLE_TRIANGLE = 7
Global Const SYMBOLSTYLE_OCTAGON = 8
Global Const SYMBOLSTYLE_ITRIANGLE = 9
Global Const SYMBOLSTYLE_HEXAGON = 10
Global Const SYMBOLSTYLE_PENTAGON = 11
Global Const SYMBOLSTYLE_STAR = 12
Global Const SYMBOLSTYLE_FILL = &H100       ' May be combined with other styles

Public Sub DPlot_FindDPLOTLIB()
    Dim hKey As Long
    Dim hLib As Long
    Dim intZeroPos As Long
    Dim lpcbData As Long
    Dim result As Long
    Dim path As String
    Dim strBuffer As String
    
    hLib = LoadLibrary("dplotlib.dll")
    If hLib <> 0 Then
        ' If LoadLibrary finds the DLL, then VB will too and there's
        ' no need to fool with changing the working directory.
        FreeLibrary (hLib)
        Exit Sub
    End If
    ' This key SHOULD have been set by the installation of DPlot Jr and/or DPlot.
    ' Or, of course, by your own program's setup routine.
    result = RegOpenKey(HKEY_CURRENT_USER, "Software\DPLOT\DPLOTLIB\Folder", hKey)
    If result = ERROR_SUCCESS Then
        ' If this fails, all hope is lost :-)
        ' The first DPLOTLIB call will result in a runtime error.
        result = RegQueryValueEx(hKey, "", 0&, REG_SZ, ByVal 0&, lpcbData)
        If result = ERROR_SUCCESS Then
            strBuffer = String(lpcbData, " ")
            result = RegQueryValueEx(hKey, "", 0&, 0&, ByVal strBuffer, lpcbData)
            intZeroPos = InStr(path, Chr$(0))
            If intZeroPos > 0 Then
                path = Left$(strBuffer, intZeroPos - 1)
            Else
                path = strBuffer
            End If
            ChDrive path
            ChDir path
        End If
        result = RegCloseKey(hKey)
    End If
End Sub
