VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DPlot_GetBitmapTest"
   ClientHeight    =   6720
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10650
   LinkTopic       =   "Form1"
   ScaleHeight     =   6720
   ScaleWidth      =   10650
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      FillColor       =   &H000000C0&
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000001&
      Height          =   6375
      Left            =   2760
      ScaleHeight     =   421
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   509
      TabIndex        =   3
      Top             =   120
      Width           =   7695
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Contour Plot - Random Data"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1560
      Width           =   2415
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Contour Plot - Gridded Data"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   2415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "XY Plot"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
   Begin VB.Label Label1 
      Height          =   735
      Left            =   120
      TabIndex        =   4
      Top             =   5640
      Width           =   2415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 0
Dim DPlotWasActive As Long
Dim rcPic As RECT
Dim hBitmap As Long
Dim hwndDPlot As Long
Dim HasMetrics As Long      ' Indicates whether we've retrieved plot dimension info using DPlot_GetBitmapEx
                            ' If non-zero, mouse movement over the picture is converted to world X,Y coordinates
                            ' in Picture1_MouseMove. If=3, then we also get Z value from DPlot_ZFromXY
                            ' Note that there's no way to convert mouse position into X,Y coordinates for
                            ' a 3D view of 3D data, though DPLOTLIB won't return an error if you try.
                            ' You can, however, get X,Y values out of a 2D view of 3D data.
Dim xLast As Long
Dim yLast As Long
Dim DPM As DPLOT_PLOTMETRICS
Dim d As DPLOT
Dim busy As Long            ' Used to ignore mouse movement while we get info from DPlot
Dim DocNum As Long
Private Sub Command1_Click()

    Dim i As Long
    Dim NP As Long
    Dim X() As Single
    Dim Y() As Single
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
        
' Plot sin(PI*x) and cos(PI*x) from x = 0 to 4.
' In this case we've used DATA_XYYY (one X array for one or more Y arrays).
'
' Since the X values are evenly spaced we could also use
' DATA_DXY  - X has only 2 elements, DX and X0
'
' And you can ALWAYS use
' DATA_XYXY - Each curve uses its own X array. This is the only
'             option available if the curves have different X values or
'             a different number of points.
        
    PI = 4# * Atn(1#)
    NP = 1001
    ReDim X(0 To NP - 1) As Single
    ReDim Y(0 To 2 * NP - 1) As Single
    
    For i = 0 To NP - 1
        X(i) = (4# * i) / (NP - 1)
        Y(i) = Sin(PI * X(i))
        Y(i + NP) = Cos(PI * X(i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_XYYY
    d.MaxCurves = 2         ' Must be >= number of curves we plot
    d.MaxPoints = NP        ' Anything >= NP will do
    d.NumCurves = 2
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.LegendX = 0.05
    d.LegendY = 0.05
    d.NP(0) = NP
    d.NP(1) = NP
    d.LineType(0) = LINESTYLE_SOLID
    d.LineType(1) = LINESTYLE_LONGDASH
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = ""
    d.Title3 = ""
    d.XAxis = "x" & Chr$(0)
    d.YAxis = "y" & Chr$(0)
        
' The command string can be as complex as you like, limited to 32K characters.
' As an alternative, if your program will be producing many similar plots then
' you might prefer to create a preferences file, edit the file with a text
' editor to remove unwanted entries, and use the [GetPreferences("filename")]
' command.
        
    cmds = "[ManualScale(0,-1.25,4,1.25)][TickInterval(1,0.5,0.25)]"
    cmds = cmds & "[Color(1,255,0,0)][Color(2,0,0,255)]"
    cmds = cmds & "[FontPoints(1,8)][FontPoints(2,12)][FontPoints(3,12)]"
    cmds = cmds & "[FontPoints(4,10)][FontPoints(5,10)][FontPoints(6,8)]"
    cmds = cmds & "[Legend(1,""sin({\sp}x)"")]"
    cmds = cmds & "[Legend(2,""cos({\sp}x)"")]"
    cmds = cmds & "[ClearEditFlag()]"
   
    ret = GetClientRect(Picture1.hwnd, rcPic)
    If (hBitmap <> 0) Then
        ret = DeleteObject(hBitmap)
        hBitmap = 0
    End If
    If DocNum <> 0 Then
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    DocNum = DPlot_Plot(d, X(0), Y(0), cmds)
    If (DocNum > 0) Then
        DPM.SIZE = Len(DPM)
        hBitmap = DPlot_GetBitmapEx(DocNum, rcPic.Right - rcPic.Left, rcPic.Bottom - rcPic.Top, DPM)
        HasMetrics = 1
    End If
    Call Picture1_Paint
    
End Sub

Private Sub Command2_Click()
    Dim i, j As Long
    Dim Nx As Long      ' Number of data columns (horizontal grid cells+1)
    Dim Ny As Long      ' Number of data rows (vertical grid cells+1)
    Dim extents(3) As Single
    Dim Z() As Single
    Dim X As Single
    Dim Y As Single
    Dim cmds As String
    Dim ret As Long
    
    HasMetrics = 0
    
    Nx = 61
    Ny = 41
    ReDim Z(Nx * Ny - 1) As Single
    extents(0) = -3     ' xlo
    extents(1) = -2     ' ylo
    extents(2) = 3      ' xhi
    extents(3) = 2      ' yhi
    
    For i = 0 To Nx - 1
        X = extents(0) + ((extents(2) - extents(0)) * i) / (Nx - 1)
        For j = 0 To Ny - 1
            Y = extents(1) + ((extents(3) - extents(1)) * j) / (Ny - 1)
            Z(i * Ny + j) = Sin(X) * Cos(Y)
        Next j
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_3D
    d.MaxCurves = Nx - 1
    d.MaxPoints = Ny - 1
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Contour3D(1)][ContourGrid(1)][ContourAxes(1)]"
    cmds = cmds & "[ContourView(20,30)][ContourLegend(0)][ContourLevels(20,-1,1)]"
    cmds = cmds & "[ContourScales(1,1,1)]"
    cmds = cmds & "[FontPoints(1,8)][FontPoints(2,12)][FontPoints(3,12)]"
    cmds = cmds & "[FontPoints(4,10)][FontPoints(5,10)][FontPoints(6,8)]"
    cmds = cmds & "[ZAxisLabel(""z"")]"
    
    ret = GetClientRect(Picture1.hwnd, rcPic)
    If (hBitmap <> 0) Then
        ret = DeleteObject(hBitmap)
        hBitmap = 0
    End If
    If DocNum <> 0 Then
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    DocNum = DPlot_Plot(d, extents(0), Z(0), cmds)
    If (DocNum > 0) Then
        hBitmap = DPlot_GetBitmap(DocNum, rcPic.Right - rcPic.Left, rcPic.Bottom - rcPic.Top)
    End If
    Call Picture1_Paint

End Sub

Private Sub Command3_Click()
'
'   Sends randomly-placed x,y,z triplets to DPlot and produces a
'   contour plot. The random feature of this example is a bit nonsensical
'   since we're using an equation to generate the data. This DPlot feature
'   is much more useful for truly random data and/or data values that
'   aren't organized on a rectangular grid.
'
    Dim Node() As Single
    Dim i As Long
    Dim Nz As Long
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    Dim rc As RECT
    
    HasMetrics = 0
    
    PI = 4# * Atn(1#)
    Nz = 1000
    ReDim Node(2, Nz - 1)
    
    For i = 0 To Nz - 1
        Node(0, i) = -PI + 2 * PI * Rnd
        Node(1, i) = -PI + 2 * PI * Rnd
        Node(2, i) = Sin(Node(0, i)) * Cos(Node(1, i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.hwnd = Me.hwnd
    d.DataFormat = DATA_3DR
    d.MaxCurves = 1
    d.MaxPoints = Nz
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Contour3D(0)][ContourGrid(0)][ContourMethod(1)]"
    cmds = cmds & "[ContourLevels(21,-1,1)][ContourLegend(0)]"
    cmds = cmds & "[FontPoints(1,8)][FontPoints(2,12)][FontPoints(3,12)]"
    cmds = cmds & "[FontPoints(4,10)][FontPoints(5,10)][FontPoints(6,8)]"
    
    ret = GetClientRect(Picture1.hwnd, rcPic)
    If (hBitmap <> 0) Then
        ret = DeleteObject(hBitmap)
        hBitmap = 0
    End If
    If DocNum <> 0 Then
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    DocNum = DPlot_Plot(d, 0&, Node(0, 0), cmds)
    If (DocNum > 0) Then
        DPM.SIZE = Len(DPM)
        hBitmap = DPlot_GetBitmapEx(DocNum, rcPic.Right - rcPic.Left, rcPic.Bottom - rcPic.Top, DPM)
        ' NOTE: If we want to get Z values from the document (HasMetrics=3), we CANNOT close it.
        ' ret = DPlot_Command(DocNum, "[FileClose()]")
        HasMetrics = 3   ' NOTE: This won't work for 3D, since we can't get X and Y from mouse position
    End If
    Call Picture1_Paint

End Sub

Private Sub Form_Load()
'
'   Ideally DPLOTLIB.DLL should reside in the same folder as your
'   compiled executable. Within the VB environment, though, finding
'   DPLOTLIB.DLL is a bit more problematic. The subroutine DPlot_FindDPLOTLIB
'   will search the registry for its location, then change the
'   working directory to that folder so that VB (actually Windows) will
'   find it.
'
    Call DPlot_FindDPLOTLIB
    hwndDPlot = DPlot_Start(1, DPlotWasActive)
    DocNum = 0
    HasMetrics = 0
    busy = 0
    Call DPlot_SetErrorMethod(2)       ' Use MessageBox to report errors
End Sub

Private Sub Form_Terminate()
    Dim ret As Long
    If DocNum <> 0 Then
        ret = DPlot_Command(DocNum, "[FileClose()]")
    End If
    If DPlotWasActive = 0 Then
        Call DPlot_Stop
    End If
    ret = DeleteObject(hBitmap)
End Sub
Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim worldx As Double
    Dim worldy As Double
    Dim worldz As Double
    Dim retval As Long
    Dim text As String
    ' IMPORTANT: We can retrieve all the scaling information we need to convert mouse position
    ' to X and Y values at the time the plot is created. This is not the case, however, for
    ' Z values from a 3D plot. For that we need to request information from DPlot, which
    ' will definitely take longer to reply than the frequency of calls to MouseMove.
    ' If we don't take a bit of preventive action we'll flood DPlot with DDE requests
    ' and it all gets ugly pretty quickly. That's the purpose of the global variable "busy".
    '
    If busy <> 0 Then
        Exit Sub
    End If
    If X = xLast And Y = yLast Then
        Exit Sub
    End If
    xLast = X
    yLast = Y
    busy = 1
    If HasMetrics <> 0 Then
        If X < DPM.hll Or X > DPM.hur Or Y < DPM.vur Or Y > DPM.vll Then
            Label1.Caption = ""
        Else
            ' This is only valid for linear scaling (which this demo uses). For other
            ' scaling types see the DPLOTLIB documentation
            worldx = DPM.xlo + (X - DPM.hll) * (DPM.xhi - DPM.xlo) / (DPM.hur - DPM.hll)
            worldy = DPM.ylo + (Y - DPM.vll) * (DPM.yhi - DPM.ylo) / (DPM.vur - DPM.vll)
            text = "X=" & Format(worldx, "##.###") & Chr$(13) & "Y=" & Format(worldy, "##.###")
            If HasMetrics = 3 Then
                retval = DPlot_ZFromXY(DocNum, worldx, worldy, worldz)
                If retval = 1 Then
                    text = text & Chr$(13) & "Z=" & Format(worldz, "##.###")
                ElseIf retval <> -1 Then
                    ' Some sort of error occurred, OTHER than X and Y outside the surface.
                    ' Reset HasMetrics so we aren't flooded by error messages with every
                    ' mouse movement.
                    HasMetrics = 1
                End If
            End If
            Label1.Caption = text
        End If
    Else
        Label1.Caption = ""
    End If
    busy = 0
End Sub

Private Sub Picture1_Paint()
    Dim bm As BITMAP
    Dim hbmpOld As Long
    Dim hdc As Long
    Dim hdcMem As Long
    Dim ret As Long

    If hBitmap <> 0 Then
        hdc = GetDC(Picture1.hwnd)
        hdcMem = CreateCompatibleDC(hdc)
        If (hdcMem <> 0) Then
            hbmpOld = SelectObject(hdcMem, hBitmap)
            ret = GetObject(hBitmap, Len(bm), bm)
            
            ret = SetBkMode(hdc, NEWTRANSPARENT)
            ret = SetBkColor(hdc, RGB(255, 255, 255))
            
            ret = BitBlt(hdc, rcPic.Left, rcPic.Top, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY)
            ret = SelectObject(hdcMem, hbmpOld)
            ret = DeleteDC(hdcMem)
        End If
        ret = ReleaseDC(Picture1.hwnd, hdc)
    End If
End Sub
