$COMPILE EXE
$RESOURCE "PBTEST4.PBR"
$INCLUDE "WIN32API.INC"
$INCLUDE "COMDLG32.INC"
#INCLUDE "CommCtrl.inc"

'===========  [ Program controls identifiers ]  =======================
%DLG_A           = 1000
%DLG_STARTX      = 1001
%DLG_ENDX        = 1002
%DLG_NUMPOINTS   = 1003
%DLG_PLOTXY      = 1004
%DLG_PLOT3DRAND  = 1005
%DLG_NUM3DRAND   = 1006
%DLG_PLOT3DGRID  = 1007
%DLG_NX          = 1008
%DLG_NY          = 1009
%DLG_EXITBUTTON  = 1010
%DLG_PICFRAME    = 1011
%DLG_COPY        = 1012
%DLG_PRINT       = 1013
%DLG_MAIN        = 1020

'===========  [ Program GLOBAL declarations ]  ========================

GLOBAL ghInst         AS DWORD         ' Module instance handle.
GLOBAL ghCurrentDlg   AS DWORD         ' Active modeless dlg handle.
TYPE XYZ
    x AS SINGLE
    y AS SINGLE
    z AS SINGLE
END TYPE

GLOBAL DPlotWasActive AS LONG
GLOBAL hemf           AS DWORD
GLOBAL SizeX          AS SINGLE
GLOBAL SizeY          AS SINGLE
GLOBAL rcFrame        AS RECT

#INCLUDE "DPLOT.INC"

'===========  [ Program ENTRY point ]  ================================
FUNCTION WINMAIN(BYVAL hCurrInstance AS LONG,_
                 BYVAL hPrevInstance AS LONG,_
                 lpCmdLine           AS ASCIIZ PTR,_
                 BYVAL nCmdShow      AS LONG) AS LONG

  ' Local variables.
  LOCAL  Msg            AS tagMsg
  LOCAL  wClass         AS WndClass
  LOCAL  hWnd           AS DWORD
  LOCAL  szClassName    AS ASCIIZ * 12

  szClassName = "PBTEST4"
  ghInst = hCurrInstance

  ' A REPLACEMENT for program PrevInstance.
  IF ISFALSE(FindWindow(szClassName, BYVAL %NULL)) THEN
     ' Fill window structure.
     wClass.style         = %CS_HREDRAW OR %CS_VREDRAW
     wClass.lpfnWndProc   = GetProcAddress(GetModuleHandle("USER32"), "DefDlgProcA")
     wClass.cbClsExtra    = 0
     wClass.cbWndExtra    = %DLGWINDOWEXTRA
     wClass.hInstance     = hCurrInstance
     wClass.hIcon         = LoadIcon(%NULL, BYVAL %IDI_APPLICATION)
     wClass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
     wClass.hbrBackground = GetStockObject(%LTGRAY_BRUSH)
     wClass.lpszMenuName  = %NULL
     wClass.lpszClassName = VARPTR(szClassName)

     ' Register the window-class.
     RegisterClass wClass
  ELSE
     ' Bring prev instance to front.
     hWnd = FindWindow(szClassName, BYVAL %NULL)
     IF IsIconic(hWnd) THEN ShowWindow hWnd ,%SW_RESTORE
     SetForegroundWindow hWnd
     ' Exit.
     FUNCTION = 0
     EXIT FUNCTION
  END IF

  ' Create the main window as a MODELESS dialog.
  hWnd = CreateDialogParam(hCurrInstance, BYVAL CLNG(%DLG_MAIN), 0, CODEPTR(MainWndProc), 0)
  ShowWindow hWnd, nCmdShow

  ' Main message loop of program.
  WHILE GetMessage(Msg, %NULL, 0, 0)
      IF ISFALSE(ghCurrentDlg) OR ISFALSE(IsDialogMessage(ghCurrentDlg, Msg)) THEN
         TranslateMessage Msg
         DispatchMessage Msg
      END IF
  WEND

  ' Clean up and assign return value.

  FUNCTION = Msg.wParam

END FUNCTION

'===============  [ MainWnd dialog window procedure ]  =================
FUNCTION MainWndProc(BYVAL hDlg    AS DWORD,_
                     BYVAL wMsg    AS DWORD,_
                     BYVAL wParam  AS DWORD,_
                     BYVAL lParam  AS DWORD) EXPORT AS LONG


  DIM A AS SINGLE
  DIM DocNum AS LONG
  DIM szExec AS ASCIIZ*512
  DIM szText AS ASCIIZ*256
  DIM StartX AS SINGLE
  DIM EndX AS SINGLE
  DIM dX AS SINGLE
  DIM dY AS SINGLE
  DIM x(2) AS SINGLE
  DIM xx AS SINGLE
  DIM xTick AS SINGLE
  DIM Y() AS SINGLE
  DIM Z() AS SINGLE
  DIM xp AS SINGLE
  DIM yp AS SINGLE
  DIM dp AS DPLOT
  DIM i AS DWORD
  DIM j AS DWORD
  DIM np AS DWORD
  DIM nx AS DWORD
  DIM ny AS DWORD
  DIM node() AS xyz
  DIM extents(4) AS SINGLE
  DIM pz AS SINGLE PTR
  DIM Colors(6) AS LONG

  SELECT CASE wMsg
      CASE %WM_INITDIALOG
          hemf = %NULL
          SetDlgItemText  hDlg, %DLG_A, "0.5"             ' "A" in Y=sin(A*PI*X) and Y=cos(A*PI*X)
          SetDlgItemText  hDlg, %DLG_STARTX, "0"          ' Starting at X =
          SetDlgItemText  hDlg, %DLG_ENDX, "4"            '  to X =
          SetDlgItemText  hDlg, %DLG_NUMPOINTS, "1001"    ' with this many equally spaced points
          SetDlgItemText  hDlg, %DLG_NUM3DRAND, "1000"    ' Default number of points in random 3D plot
          SetDlgItemText  hDlg, %DLG_NX, "50"             ' Divisions on X and
          SetDlgItemText  hDlg, %DLG_NY, "50"             '  Y axes for 3D grid

          GetWindowRect GetDlgItem hDlg, %DLG_PICFRAME, rcFrame
          InflateRect rcFrame, -3, -3
          MapWindowPoints %NULL, hDlg, rcFrame, 2

          ' Size of the metafile to retrieve, in inches. The actual size specified isn't critical
          ' *unless* we want font sizes in our output to exactly match what we specify. What IS
          ' fairly important is that the aspect ratio matches the aspect ratio of the output.
          SizeX = 5.0
          SizeY = (SizeX * (rcFrame.nBottom - rcFrame.nTop +1 ))/(rcFrame.nRight - rcFrame.nLeft + 1)

          ' Start up DPlot (or DPlot Jr). This isn't strictly necessary since all of the
          ' DPlot_Plot* functions will start DPlot themselves, but plots will be produced
          ' much faster if we don't have to restart DPlot every time. We start it hidden,
          ' and keep track of whether it was this program that opened DPlot or not with
          ' "DPlotWasActive". If that value is 0, then we'll clean up after ourselves when
          ' we quit by calling DPlot_Stop.
          DPlot_Start(1, DPlotWasActive)

          ' Use MessageBox for error messages in DPLOTLIB
          DPlot_SetErrorMethod(2)

          ' Let dialogbox engine set the focus.
          FUNCTION = %TRUE

      CASE %WM_ACTIVATE
          IF LOWRD(wParam) = 0 THEN  ' Dialog becoming inactive.
              ghCurrentDlg = 0
          ELSE                       ' Dialog becoming active.
              ghCurrentDlg = hDlg
          END IF
          FUNCTION = %TRUE

      CASE %WM_DESTROY
          ' Send a message to terminate message loop.
          PostQuitMessage 0
          FUNCTION = %TRUE

      CASE %WM_PAINT
          LOCAL hDC  AS DWORD
          LOCAL ps AS PAINTSTRUCT
          hDC = BeginPaint(hDlg, ps)
          FillRect(hdc,rcFrame,GetStockObject(%WHITE_BRUSH))
          IF (hemf <> %NULL) THEN PlayEnhMetaFile(hdc,hemf,rcFrame)
          EndPaint(hDlg, ps)
          FUNCTION = %TRUE

      CASE %WM_COMMAND
          SELECT CASE LOWRD(wParam)
              CASE %DLG_PLOTXY
                  GetDlgItemText  hDlg, %DLG_A, szText, SIZEOF(szText)
                  A = VAL(szText)
                  GetDlgItemText  hDlg, %DLG_STARTX, szText, SIZEOF(szText)
                  StartX = VAL(szText)
                  GetDlgItemText  hDlg, %DLG_ENDX, szText, SIZEOF(szText)
                  EndX = VAL(szText)
                  GetDlgItemText  hDlg, %DLG_NUMPOINTS, szText, SIZEOF(szText)
                  NP = VAL(szText)

                  IF NP < 2 THEN
                      MessageBox hDlg, "The number of points must be greater than 1.", "Demo", %MB_OK
                      FUNCTION = %TRUE
                      EXIT FUNCTION
                  END IF

                  dX = (EndX - StartX) / CSNG(NP - 1)
                  x(0) = dX
                  x(1) = StartX
                  REDIM y(NP * 2)
                  FOR i = 1 TO np - 1
                      xx = StartX + CSNG(i) * dX
                      y(i) = SIN(A * 3.141592654 * xx)
                      y(i+NP) = COS(A * 3.141592654 * xx)
                  NEXT

                  RESET dp
                  dp.Version = %DPLOT_DDE_VERSION
                  dp.hwnd = hDlg
                  dp.DataFormat = %DATA_DXY
                  dp.MaxCurves = 2
                  dp.MaxPoints = NP
                  dp.NumCurves = 2
                  dp.Scalecode = %SCALE_LINEARX_LINEARY
                  dp.LegendX = 0.05
                  dp.LegendY = 0.05
                  dp.NP(0) = NP
                  dp.NP(1) = NP
                  dp.LineType(0) = %LINESTYLE_SOLID
                  dp.LineType(1) = %LINESTYLE_LONGDASH
                  IF(A = 1) THEN
                     MID$(dp.Legend, 41, 40) = "sin({\sp}x)"
                     MID$(dp.Legend, 81, 40) = "cos({\sp}x)"
                  ELSE
                     MID$(dp.Legend, 41, 40) = "sin(" + STR$(A) + "{\sp}x)"
                     MID$(dp.Legend, 81, 40) = "cos(" + STR$(A) + "{\sp}x)"
                  END IF
                  dp.XAxis = "x" + CHR$(0)
                  dp.YAxis = "y" + CHR$(0)
                  dp.Title1 = "DPlot_GetEnhMetaFile Demo"
                  ' Take a stab at a reasonable tick mark interval on the X axis
                  xTick = 0.25
                  WHILE((EndX-StartX)/xTick > 12)
                      xTick = xTick * 2
                  WEND
                  szExec = "[ManualScale(" & STR$(StartX) & ",-1.25," & STR$(EndX) & ",1.25)]"
                  szExec = szExec & "[TickInterval(1," & STR$(xTick) & ",0.25)]"
                  szExec = szExec & "[Caption(" & CHR$(34) & "CTEST4 Example 1" & CHR$(34) & ")]"
                  szExec = szExec & "[Color(1,255,0,0)][Color(2,0,0,255)][LineWidth(-2,20)][LineWidth(-1,20)][LineWidth(0,10)]"
                  szExec = szExec & "[TextFont(1, 8,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  szExec = szExec & "[TextFont(2,12,700,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  szExec = szExec & "[TextFont(4,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  szExec = szExec & "[TextFont(5,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  szExec = szExec & "[TextFont(6,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  szExec = szExec & "[ClearEditFlag()]"
                  IF hemf THEN
                      DeleteEnhMetaFile hemf
                      hemf = %NULL
                  END IF
                  DocNum = DPlot_Plot(dp, x(0), y(0), szExec)
                  hemf = DPlot_GetEnhMetaFile(DocNum,SizeX,SizeY)
                  DPlot_Command(DocNum,"[FileClose()]")
                  InvalidateRect hDlg,rcFrame,%TRUE
                  ERASE Y()
                  IF hemf THEN
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%TRUE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%TRUE)
                  ELSE
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%FALSE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%FALSE)
                  END IF
                  FUNCTION = %TRUE

              CASE %DLG_PLOT3DRAND
                  LOCAL dummy AS SINGLE

                  ' Plot random 3D points, generating a contour plot
                  GetDlgItemText hDlg, %DLG_NUM3DRAND, szText, SIZEOF(szText)
                  NP = VAL(szText)
                  IF( NP < 3 ) THEN
                    MSGBOX "The number of points must be greater than 2.",%MB_OK, "Demo"
                    FUNCTION = %TRUE
                    EXIT FUNCTION
                  END IF
                  ' Generate the data in the range -PI < X < PI, -PI < Y < PI, Z=cos(X)*sin(Y)
                  REDIM node(NP)
                  FOR j=0 TO NP
                      node(j).x = -3.141592654 + 2*3.141592654 * RND()
                      node(j).y = -3.141592654 + 2*3.141592654 * RND()
                      node(j).z = (COS(node(j).x) * SIN(node(j).y))
                  NEXT
                  RESET dp
                  dp.Version     = %DPLOT_DDE_VERSION
                  dp.hwnd        = hDlg
                  dp.DataFormat  = %DATA_3DR
                  dp.MaxCurves   = 1                  ' ALWAYS 1 for 3DR
                  dp.MaxPoints   = NP
                  dp.NumCurves   = 1                  ' Ditto
                  dp.Scalecode   = %SCALE_LINEARX_LINEARY
                  dp.Title1      = "DPLOT_GetEnhMetaFile Demo"
                  dp.XAxis       = "X"
                  dp.YAxis       = "Y"
                  szExec = "[ContourLegend(0)][Contour3D(0)][ContourMethod(1)][ContourLevels(21,-1,1)]" & _
                           "[ContourColorScheme(1)][Caption(" & CHR$(34) & "CTEST4 Example 2" & CHR$(34) & ")]" & _
                           "[TextFont(1, 8,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(2,12,700,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(4,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(5,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(6,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]"
                  IF(hemf) THEN
                      DeleteEnhMetaFile(hemf)
                      hemf = %NULL
                  END IF
                  DocNum = DPlot_Plot(dp,dummy,node(0),szExec)
                  hemf = DPlot_GetEnhMetaFile(DocNum,SizeX,SizeY)
                  DPlot_Command(DocNum,"[FileClose()]")
                  InvalidateRect hDlg,rcFrame,%TRUE
                  ERASE Y()
                  IF hemf THEN
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%TRUE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%TRUE)
                  ELSE
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%FALSE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%FALSE)
                  END IF
                  FUNCTION = %TRUE

              CASE %DLG_PLOT3DGRID

                  ' Plot 3D points on a rectangular grid, generating a contour plot
                  GetDlgItemText hDlg,%DLG_NX,szText,SIZEOF(szText)
                  NX = VAL(szText)
                  GetDlgItemText hDlg,%DLG_NY,szText,SIZEOF(szText)
                  NY = VAL(szText)

                  IF (NX < 1) THEN
                      MSGBOX "NX must be greater than 0.",%MB_OK,"Demo"
                      FUNCTION = %TRUE
                      EXIT FUNCTION
                  END IF
                  IF (NY < 1 ) THEN
                      MSGBOX "NY must be greater than 0.",%MB_OK,"Demo"
                      FUNCTION = %TRUE
                      EXIT FUNCTION
                  END IF

                  '  Generate the data. - NP randomly placed points
                  '  in the range -PI < X < PI, -PI < Y < PI, Z=cos(X)*sin(Y)
                  REDIM Z((NX + 1) * (NY + 1))
                  extents(0) = -3.141592654
                  extents(1) = -3.141592654
                  extents(2) =  3.141592654
                  extents(3) =  3.141592654

                  dX = 2*3.141592654 / NX
                  dY = 2*3.141592654 / NY
                  pz = VARPTR(z(0))
                  FOR i = 0 TO NX
                      XP = -3.141592654 + i*dX
                      FOR j = 0 TO NY
                          YP = -3.141592654 + j*dY
                          @pz = (COS(XP) * SIN(YP))
                          INCR pz
                      NEXT
                  NEXT

                  ' Custom colors
                  Colors(0) = RGB(0, 255, 0)
                  Colors(1) = RGB(51, 204, 0)
                  Colors(2) = RGB(102, 153, 0)
                  Colors(3) = RGB(153, 102, 0)
                  Colors(4) = RGB(204, 51, 0)
                  Colors(5) = RGB(255, 0, 0)

                  RESET dp
                  dp.Version    = %DPLOT_DDE_VERSION
                  dp.hwnd       = hDlg
                  dp.DataFormat = %DATA_3D
                  dp.MaxCurves  = NX
                  dp.MaxPoints  = NY
                  dp.NumCurves  = 1
                  dp.Scalecode  = %SCALE_LINEARX_LINEARY
                  dp.Title1     = "DPLOT_GetEnhMetaFile Demo"
                  dp.XAxis      = "X"
                  dp.YAxis      = "Y"
                  szExec = "[ContourLegend(0)][Contour3D(0)][ContourMethod(1)][ContourGrid(0)]" & _
                           "[ContourAxes(1)][ContourLevels(21,-1,1)]" & _
                           "[Caption(" & CHR$(34) & "CTEST4 Example 3" & CHR$(34) & ")]" & _
                           "[TextFont(1, 8,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(2,12,700,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(4,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(5,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[TextFont(6,10,  0,0,0,0,0," & CHR$(34) & "Arial" & CHR$(34) & ")]" & _
                           "[ContourColorScheme(2)]" & _
                           "[ContourCustomColors(" & _
                               STR$(Colors(0)) & "," & STR$(Colors(1)) & "," & _
                               STR$(Colors(2)) & "," & STR$(Colors(3)) & "," & _
                               STR$(Colors(4)) & "," & STR$(Colors(5)) & ")]"
                  IF hemf THEN
                      DeleteEnhMetaFile hemf
                      hemf = %NULL
                  END IF

                  DocNum = DPlot_Plot(dp,extents(0),z(0),szExec)
                  hemf = DPlot_GetEnhMetaFile(DocNum,SizeX,SizeY)
                  DPlot_Command(DocNum,"[FileClose()]")
                  InvalidateRect hDlg,rcFrame,%TRUE
                  ERASE z()
                  IF hemf THEN
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%TRUE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%TRUE)
                  ELSE
                      EnableWindow(GetDlgItem(hDlg,%DLG_COPY),%FALSE)
                      EnableWindow(GetDlgItem(hDlg,%DLG_PRINT),%FALSE)
                  END IF
                  FUNCTION = %TRUE

              CASE %DLG_COPY
                  IF hemf THEN
                      LOCAL hemfCopy AS DWORD
                      OpenClipboard(hDlg)
                      EmptyClipboard()
'                     hemfCopy = CopyEnhMetaFile(hemf,0&)
                      hemfCopy = CopyEnhMetaFile(hemf,"")
                      SetClipboardData(%CF_ENHMETAFILE,hemfCopy)
                      CloseClipboard()
                  ELSE
                      MessageBeep(-1)
                  END IF
                  FUNCTION = %TRUE

              CASE %DLG_PRINT
                  IF hemf THEN
                      LOCAL pd AS PRINTDLGAPI
                      LOCAL di AS DOCINFO
                      LOCAL rc AS RECT
                      LOCAL resX AS LONG
                      LOCAL resY AS LONG
                      LOCAL MaxSizeX AS SINGLE      ' Max. size of output, in dots (accounting for margins)
                      LOCAL MaxSizeY AS SINGLE
                      LOCAL ActSizeX AS SINGLE      ' Actual output size, in dots
                      LOCAL ActSizeY AS SINGLE
                      LOCAL sc AS SINGLE            ' Scale factor we use to fit picture on the page
                      LOCAL ret AS LONG
                      LOCAL Margin AS SINGLE        ' Print margin - nothing fancy, we'll use 1/4 inch on all sides
                      LOCAL Caption AS STRING

                      pd.lStructSize = SIZEOF(pd)
                      pd.hwndOwner = hDlg
                      pd.flags = %PD_RETURNDC OR %PD_NOPAGENUMS OR %PD_NOSELECTION
                      pd.nCopies = 1
                      ret = PrintDlg(pd)
                      IF (ret = 0) THEN
                          FUNCTION = %TRUE
                          EXIT FUNCTION
                      END IF
                      IF (pd.nCopies = 0) THEN
                          FUNCTION = %TRUE
                          EXIT FUNCTION
                      END IF
                      resX = GetDeviceCaps(pd.hdc, %LOGPIXELSX)
                      resY = GetDeviceCaps(pd.hdc, %LOGPIXELSY)
                      Margin = 0.25
                      MaxSizeX = GetDeviceCaps(pd.hdc, %HORZRES) - 2 * Margin * resX
                      MaxSizeY = GetDeviceCaps(pd.hdc, %VERTRES) - 2 * Margin * resY
                      EnableWindow(hDlg, 0)
                      di.cbSize = SIZEOF(di)
                      Caption = "DPlot_EnhMetaFile Demo"
                      di.lpszDocName = STRPTR(Caption)
                      WHILE (pd.nCopies > 0)
                          IF (StartDoc(pd.hdc, di) <> 0) THEN
                              StartPage(pd.hdc)
                              ' Center on the page, with at least PRINT_MARGIN margins.
                              ' Compress the image if necessary, maintaining the
                              ' SizeX/SizeY aspect ratio
                              ActSizeX = SizeX * resX
                              ActSizeY = SizeY * resY
                              IF (ActSizeX > MaxSizeX OR ActSizeY > MaxSizeY) THEN
                                  sc = MaxSizeX / ActSizeX
                                  IF (sc > MaxSizeY / ActSizeY) THEN
                                      sc = MaxSizeY / ActSizeY
                                  END IF
                                  ActSizeX = ActSizeX * sc
                                  ActSizeY = ActSizeY * sc
                              END IF
                              rc.nLeft = (Margin * resX + (MaxSizeX - ActSizeX) / 2)
                              rc.nTop = (Margin * resY + (MaxSizeY - ActSizeY) / 2)
                              rc.nRight = rc.nLeft + ActSizeX
                              rc.nBottom = rc.nTop + ActSizeY
                              PlayEnhMetaFile(pd.hdc, hemf, rc)
                              EndPage(pd.hdc)
                              EndDoc(pd.hdc)
                          END IF
                          pd.nCopies = pd.nCopies - 1
                      WEND
                      EnableWindow(hDlg, 1)
                      DeleteDC(pd.hdc)
                      IF (pd.hDevMode <> 0) THEN GlobalFree(pd.hDevMode)
                      IF (pd.hDevNames <> 0) THEN GlobalFree(pd.hDevNames)
                  ELSE
                      MessageBeep(-1)
                  END IF
                  FUNCTION = %TRUE

              CASE ELSE
                  FUNCTION = %FALSE

          END SELECT

      CASE %WM_SYSCOMMAND
          SELECT CASE wParam
              CASE %SC_CLOSE
                  IF(DPlotWasActive = 0) THEN DPlot_Stop()
                  IF hemf THEN DeleteEnhMetaFile(hemf)
                  DestroyWindow hDlg
                  FUNCTION = %TRUE
          END SELECT

      CASE ELSE
          FUNCTION = %FALSE

      END SELECT

END FUNCTION
